; --- drag and drop code taken from
; --- Iczelion's tutorial # 19

.486 					
.model flat, stdcall 	
option casemap: none 	

include windows.inc
include user32.inc
include kernel32.inc
include comctl32.inc
include gdi32.inc

includelib user32.lib
includelib kernel32.lib
includelib comctl32.lib
includelib gdi32.lib

include ListView.asm

DlgProc proto :DWORD,:DWORD,:DWORD,:DWORD ; --- main dialog procedure
DoImageList proto

.const
	
	IDD_MAIN equ 1001
	IDC_LISTVIEW equ 1002
	ICO1 equ 2000
	
.data
	
	szGroup db 'Drag',0
	szDragThis db 'Drag this...',0
	szColumnName db 'List Data',0
	
.data?

	hInstance dd ?
	hList dd ?
	hBitmap dd ?
	hImageList dd ?
	hDragImageList dd ?
	bDrag BOOL ?

.code

start:

	invoke GetModuleHandle,NULL
	mov hInstance, eax
	invoke DialogBoxParam,hInstance,IDD_MAIN,0,addr DlgProc,0
	invoke ExitProcess,eax

DlgProc	proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	local icc:INITCOMMONCONTROLSEX
	local tvhit:TV_HITTESTINFO
	local mpt:POINT
	
	.if uMsg == WM_INITDIALOG
		
		mov icc.dwICC, ICC_LISTVIEW_CLASSES or ICC_STANDARD_CLASSES		
		mov icc.dwSize, sizeof icc
		
		invoke InitCommonControlsEx,addr icc
		
		invoke GetDlgItem,hWin,IDC_LISTVIEW
		mov hList, eax
		
		invoke DoImageList ; --- add images
			
		invoke SendMessage,hList,LVM_SETIMAGELIST,LVSIL_SMALL,hImageList
		
		mov eax, LVS_EX_BORDERSELECT
		INVOKE SendMessage, hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
		; --- insert test data
		invoke InsertListColumn,hList,offset szColumnName,300,0
		invoke InsertListItem,hList,addr szDragThis,NULL,0,0

	.elseif uMsg == WM_NOTIFY
		.if wParam == IDC_LISTVIEW
			mov eax, lParam
			mov ecx, (NM_LISTVIEW ptr [eax]).hdr.code 
			.if ecx == LVN_BEGINDRAG
				; ------ ****
				mov ecx, (NM_LISTVIEW ptr [eax]).iItem
				invoke SendMessage,hList,LVM_CREATEDRAGIMAGE,ecx,addr mpt
				mov hDragImageList, eax
				invoke ImageList_BeginDrag,hDragImageList,0,0,0
				mov eax, lParam
				mov ecx, (NM_LISTVIEW ptr [eax]).ptAction.x
				mov ecx, (NM_LISTVIEW ptr [eax]).ptAction.y
				invoke ImageList_DragEnter,hWin,ecx,ecx
				; ------ ****
				invoke SetCapture,hWin
				mov bDrag, TRUE
			.endif	
		.endif	
	.elseif uMsg == WM_MOUSEMOVE
		.if bDrag == TRUE
			mov eax,lParam
			and eax,0ffffh
			add eax, 200
			mov ecx,lParam
			shr ecx,16
			sub eax,200 ; --- not sure why i'm doing this
			add ecx, 40 ; --- not sure why i'm doing this
			mov tvhit.pt.x,eax 
			mov tvhit.pt.y,ecx	
			mov tvhit.flags,TVHT_ONITEM
			invoke ImageList_DragMove,eax,ecx
		.endif
	.elseif uMsg == WM_LBUTTONUP
		.if bDrag == TRUE
			invoke ImageList_DragLeave,hList
			invoke ImageList_EndDrag
			invoke ImageList_Destroy,hDragImageList
			invoke ReleaseCapture
			mov bDrag,FALSE
		.endif
	
	.elseif uMsg == WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov eax, FALSE
		ret	
	.endif

	mov eax, TRUE
	Ret
DlgProc EndP

DoImageList proc
	
	invoke ImageList_Create,16,16,ILC_COLOR16,1,10
	mov hImageList, eax	
	
	invoke LoadBitmap,hInstance,ICO1
	mov hBitmap, eax
	invoke ImageList_Add,hImageList,hBitmap,NULL ;0
	
	invoke DeleteObject,hBitmap
	
	xor eax, eax
	Ret
DoImageList EndP

end start